//
//  GSPathOperator.h
//  PathOperations
//
//  Created by Georg Seifert on 03.03.14.
//  Copyright (c) 2014 Georg Seifert. All rights reserved.
//

#import <Foundation/Foundation.h>

#import <GlyphsCore/GSPathSegment.h>

typedef struct {
	NSPoint results[10];
	uint8 count;
} GSIntersectResultsStruct;

void GSIntersectBezier3Bezier3SegmentsOperations(GSSegmentStruct *P, GSSegmentStruct *Q, GSIntersectResultsStruct *results, int Depth);

@class GSPath;

CGFloat GSMultiplicator(NSPoint a, NSPoint b, NSPoint c);

typedef NS_ENUM(NSInteger, GSPathOperations) {
	GSRemoveOverlap,
	GSSubtract,
};

@interface GSPathOperator : NSObject {}

+ (BOOL)removeOverlapPaths:(NSMutableArray <GSPath *> *)paths error:(NSError **)error;
+ (BOOL)removeOverlapPaths:(NSArray *)paths intoPen:(id<GSPenProtocol>)pen error:(out NSError **)error;
+ (NSMutableArray<GSPathSegment *> *)removeOverlapSegments:(NSArray <GSPathSegment *> *)originalSegments error:(out NSError **)error __attribute__((ns_returns_retained));
+ (BOOL)subtractPaths:(NSMutableArray <GSPath *>*)subtractPaths from:(NSMutableArray <GSPath *> *)paths error:(NSError **)error;
+ (BOOL)subtractPaths:(NSMutableArray <GSPath *>*)subtractPaths from:(NSMutableArray <GSPath *> *)paths keepOverlaps:(BOOL)keepOverlaps error:(NSError **)error;
+ (BOOL)intersectPaths:(NSMutableArray <GSPath *>*)subtractPaths from:(NSMutableArray <GSPath *> *)paths error:(NSError **)error;
+ (NSArray *)segmentsFromPaths:(NSArray <GSPath *> *)paths;
+ (void)addIntersections:(NSMutableArray <GSPathSegment *> *)segments;
+ (void)addIntersections:(NSMutableArray <GSPathSegment *> *)Segments otherSegments:(NSMutableArray <GSPathSegment *> *)OtherSegments;
@end
